/*
 * NAT - An universal Translator
 * Copyright (C) 2005 Bruno Mascret
 * Contact: bmascret@free.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

package ui;

import javax.swing.JPanel;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import nat.Nat;

public class ConfTranscription extends JPanel implements ActionListener
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Nat nat;

	private JCheckBox abreger = new JCheckBox("Braille Abrg");
	
	private JCheckBox bLit = new JCheckBox("Traiter les critures litraires");
	private JCheckBox bMaths = new JCheckBox("Traiter les critures mathmatiques");
	
	private JComboBox comboTables = new JComboBox();
	private JLabel lComboTables = new JLabel("Table Braille");
	private JButton btEditTable =new JButton("Editer la table");
	
	public ConfTranscription(Nat nat)
	{
		super();
		this.nat = nat;
		bLit.setSelected(nat.getTraiterLiteraire());
		bMaths.setSelected(nat.getTraiterMaths());
		add(bLit);
		add(bMaths);
		
		abreger.setSelected(nat.getAbreger());
		add(abreger);
		File repertoire =new File("xsl/tablesBraille");
	    System.out.println ( repertoire.getAbsolutePath());
        File[] listTables = repertoire.listFiles();
        for(int i=0;i<listTables.length;i++)
        {
        	if (listTables[i].getName().endsWith(".ent") && !listTables[i].getName().equals("Brltab.ent"))
        	{
        		comboTables.addItem(listTables[i].getName().substring(0,listTables[i].getName().length()-4));
        	}
        }
        /*
		comboTables.addItem("CBFr1252");
		comboTables.addItem("DuxFr");
		comboTables.addItem("CodeUs");
		comboTables.addItem("TableBraille");*/
		JPanel panTables = new JPanel();
		lComboTables.setLabelFor(comboTables);
		btEditTable.addActionListener(this);
		panTables.add(lComboTables);
		panTables.add(comboTables);
		panTables.add(btEditTable);
		
		add(panTables);
		
	}
	
	public void actionPerformed(ActionEvent evt)
	{
		if (evt.getSource()==btEditTable)
		{
			ConfTableBraille ctb = new ConfTableBraille(comboTables.getSelectedItem().toString(),nat);
			ctb.setVisible(true);
		}
	}
	public void Enregistrer()
	{
		nat.setAbreger(abreger.isSelected());
		nat.setTraiterLiteraire(bLit.isSelected());
		nat.setTraiterMaths(bMaths.isSelected());
	}

}
