/*
 * NAT - An universal Translator
 * Copyright (C) 2005 Bruno Mascret
 * Contact: bmascret@free.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

package ui;

import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import javax.swing.JButton;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
//import javax.swing.ImageIcon;

import nat.Nat;

public class Configuration extends JFrame implements ActionListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JTabbedPane onglets = new JTabbedPane();
	private ConfGeneral panGen;
	private ConfConversion panConversion;
	private ConfTranscription panTranscription;
	private ConfPostTraitement panPostTraitement;
	private ConfInterface panInterface;
	private JPanel lesBoutons = new JPanel();
	private JButton btAnnuler = new JButton("Annuler");
	private JButton btEnregistrer = new JButton("Enregistrer");
	

	public Configuration(Nat nat)
	{
		super("Configuration de NAT");
		panGen = new ConfGeneral(nat);
		panConversion = new ConfConversion(nat);
		panTranscription = new ConfTranscription(nat);
		panPostTraitement = new ConfPostTraitement(nat);
		panInterface = new ConfInterface(nat);
		//ImageIcon icon = createImageIcon("images/middle.gif");
		onglets.addTab("Gnral",panGen);
		onglets.addTab("Conversion",panConversion);
		onglets.addTab("Transcription",panTranscription);
		onglets.addTab("PostTraitement",panPostTraitement);
		onglets.addTab("Interface",panInterface);
		
		btAnnuler.addActionListener(this);
		btEnregistrer.addActionListener(this);
		lesBoutons.add(btEnregistrer);
		lesBoutons.add(btAnnuler);
		add("Center",onglets);
		add("South",lesBoutons);
		setSize(new Dimension(500,400));

	}
	
	public void actionPerformed(ActionEvent evt)
	{
		if (evt.getSource() == btAnnuler)
		{
			this.dispose();
		}
		else if (evt.getSource() == btEnregistrer)
		{
			System.out.println("Editeur de configuration en dveloppement");
			panGen.Enregistrer();
			panConversion.Enregistrer();
			panTranscription.Enregistrer();
			panPostTraitement.Enregistrer(); 
			panInterface.Enregistrer();
			this.dispose();
		}
	}

}
