/*
 * NAT - An universal Translator
 * Copyright (C) 2005 Bruno Mascret
 * Contact: bmascret@free.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

package ui;

// *** Composants graphiques ***
import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JTextArea;
//import javax.swing.JTextPane;
import javax.swing.JScrollPane;
//import javax.swing.text.StyledDocument;
//import javax.swing.text.Style;
//import javax.swing.text.BadLocationException;
//import javax.swing.text.StyleConstants;
//import javax.swing.text.AttributeSet;
//import javax.swing.text.MutableAttributeSet;
//import java.awt.Font;
//import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.*;
//import java.io.File;
//import java.io.RandomAccessFile;
//import java.io.IOException;
//import java.awt.Graphics;
//import java.awt.Image;

//*** Gestionnaires ***
import gestionnaires.GestionnaireOuvrir;
import gestionnaires.GestionnaireErreur;
import gestionnaires.GestionnaireOuvrirFenetre;

// *** Classes du modle ***
import nat.Convertisseur;
import nat.Transcodeur;
import nat.Nat;


public class FenetrePrinc extends JFrame implements ActionListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel hautFenetre = new JPanel();
	private JLabel lTitre = new JLabel("<html><center><h1>NAT</h1></center></html>");
	private JTextField  entreeXML = new JTextField("documents/xml.xml",30);
	private JLabel lEntree = new JLabel("Source");
	private JButton ouvrirSource = new JButton("Slectionner source");
	private JTextField  sortie = new JTextField("documents/sortie.txt",30);
	private JLabel lSortie = new JLabel("Sortie");
	private JButton ouvrirSortie = new JButton("Slectionner sortie");
	//*********************************//
	private JPanel commandesPrinc =new JPanel();
	private JButton transcrire = new JButton("Transcrire");
	private JButton btEditeur = new JButton("Ouvrir le fichier transcrit");
//	*********************************//
	private JTextField  filtre = new JTextField("xsl.xsl",20);
//	private JLabel lFiltre = new JLabel("Filtre XSL");
//	private JButton ouvrirFiltre = new JButton("Selectionner filtre");
//	*********************************//
	private JCheckBox debug = new JCheckBox();
	private JTextArea panneauLog = new JTextArea (15,40);
	private JPanel panneauAffichage = new JPanel();
//	*********************************//
	private JButton btOption = new JButton("Options");
	private JButton btAide = new JButton("Aide");
	private JButton btAPropos = new JButton("A propos...");
	private JPanel enBas =new JPanel();
//	*********************************//
	private Transcodeur transcodeur;
	private Convertisseur convertisseur;
	private GestionnaireErreur gestErreur;
//	*********************************//
	private Nat nat;
	
	//constructeur
	public FenetrePrinc(Convertisseur conv, Transcodeur trans, Nat n)
	{
		super("NAT");
		this.setIconImage(getToolkit().getImage("nat.gif"));
		transcodeur = trans;
		convertisseur = conv;
		nat = n;
		FabriqueFenetre();
	}
	//mthode d'accs
	public JTextField getEntree()
	{
		return entreeXML;
	}
	
	public JTextField getFiltre()
	{
		return filtre;
	}
	
	public void setEntree(String entree)
	{
		entreeXML.setText(entree);
	}
	
	public void setFiltre(String filtre)
	{
		this.filtre.setText(filtre);
	}
	
	public void setSortie(String sortie)
	{
		this.sortie.setText(sortie);
	}
	
	//mthodes
	private void FabriqueFenetre()
	{
		setLayout(new BorderLayout(5, 5));
		
		/* **Haut de la fentre principale ****/
		hautFenetre.setLayout(new BorderLayout(5,5));
		hautFenetre.setPreferredSize(new Dimension(600,180));
		JPanel panelTitre = new JPanel();
		panelTitre.add(lTitre);
		JPanel panSource = new JPanel();
		ouvrirSource.addActionListener(new GestionnaireOuvrir(this,GestionnaireOuvrir.OUVRIR_SOURCE));
		lEntree.setLabelFor(entreeXML);
		panSource.add(lEntree);
		panSource.add(entreeXML);
		panSource.add(ouvrirSource);
		JPanel panSortie = new JPanel();
		ouvrirSortie.addActionListener(new GestionnaireOuvrir(this,GestionnaireOuvrir.OUVRIR_SORTIE));
		lSortie.setLabelFor(sortie);
		panSortie.add(lSortie);
		panSortie.add(sortie);
		panSortie.add(ouvrirSortie);
		JPanel lesFichiers = new JPanel();
		lesFichiers.add(panSource);
		lesFichiers.add(panSortie);
		
		transcrire.addActionListener(this);
		btEditeur.addActionListener(this);
		btEditeur.setEnabled(false);
		commandesPrinc.add(transcrire);
		commandesPrinc.add(btEditeur);
		hautFenetre.add("North",panelTitre);
		hautFenetre.add("Center",lesFichiers);
		hautFenetre.add("South",commandesPrinc);

		add("North",hautFenetre);
		
		debug.setText("Debugage actif");
		
		panneauLog.setEditable(false);
		panneauLog.setLineWrap(true);
		JScrollPane scrollLog = new JScrollPane (panneauLog);
		scrollLog.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollLog.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		panneauAffichage.add(scrollLog);
		add("Center",panneauAffichage);
		
		btOption.addActionListener(new GestionnaireOuvrirFenetre(GestionnaireOuvrirFenetre.OUVRIR_OPTIONS,nat));
		btAide.addActionListener(new GestionnaireOuvrirFenetre(GestionnaireOuvrirFenetre.OUVRIR_AIDE,nat));
		btAPropos.addActionListener(new GestionnaireOuvrirFenetre(GestionnaireOuvrirFenetre.OUVRIR_APROPOS,nat));
		enBas.add(btOption);
		enBas.add(btAide);
		enBas.add(btAPropos);
		add("South",enBas);
		
		//saisieFichier.setPreferredSize(new Dimension(450,150));
		panneauAffichage.setPreferredSize(new Dimension(600,300));
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	public void AfficheFichier(String nomFichier)
    {
		Editeur editeur = new Editeur();
		if (!nat.getEditeurEnBraille())
		{
			editeur.AfficheFichier( nomFichier,Editeur.EN_NOIR);
		}
		else
		{
			editeur.AfficheFichier( nomFichier,Editeur.EN_BRAILLE);
		}
		editeur.pack();
		editeur.setVisible(true);
		/*
		//Prparation des styles pour le JTextPane
	    StyledDocument doc = zoneTexte.getStyledDocument();
	    
	    //En Braille
	    //Style style = zoneTexte.addStyle("EnBraille", null);
	    MutableAttributeSet attrs = zoneTexte.getInputAttributes();
	    Font fonteBraille = new Font("Braille Antoine", Font.PLAIN, 20);
	    Font fonteNoir = new Font("Courier", Font.PLAIN, 20);
	    //StyleConstants.setForeground(attrs, Color.red); ok
	
		zoneTexte.setText("");
	    try
	      {
	      RandomAccessFile raf = new RandomAccessFile(nomFichier, "r");
	      String ligne;
	      while ( (ligne = raf.readLine()) != null )
		  	{
	    	  //en noir
	    	  StyleConstants.setFontFamily(attrs, fonteNoir.getFamily());
	    	  StyleConstants.setFontSize(attrs,18);
	    	  doc.insertString(doc.getLength(), ligne + "\n", attrs);//doc.getStyle("EnBraille"));
	    	  //en braille
	    	  StyleConstants.setFontFamily(attrs, fonteBraille.getFamily());
	    	  StyleConstants.setFontSize(attrs,15);
	    	  doc.insertString(doc.getLength(), ligne + "\n", attrs);
	  	    }
	      }
	    
	   catch (BadLocationException ble)
	    {
	  	    System.err.println("Impossible d'afficher le texte");
	  	}
	   catch (IOException e)
	     {
	     System.out.println("erreur dans: " + e);
	     }*/
    }

	
	//mthodes redfinies
	public void actionPerformed(ActionEvent evt)
	{
		//lancer transcription
		if (evt.getSource() == transcrire)
		{
			btEditeur.setEnabled(false);
			this.repaint();
			if ((entreeXML.getText().length()<1)||(filtre.getText().length()<1)||(sortie.getText().length()<1))
			{
				System.out.println("Entrez un fichier source et un fichier cible");
				panneauLog.setText("Entrez un fichier source et un fichier cible");
			}
			else
			{
				panneauLog.setText("");
				panneauLog.paintImmediately(new Rectangle(0,0,panneauLog.getWidth(),panneauLog.getHeight()));
				//resultat.setText("");
				//resultat.paintImmediately(0,0,panneauAffichage.getWidth(),panneauAffichage.getHeight());
				gestErreur = new GestionnaireErreur(null,panneauLog);
				gestErreur.setModeDebugage(debug.isSelected());
				//System.out.println("\nTEST DEBUG: "+debug.isSelected());
				if (entreeXML.getText().endsWith(".txt"))
				{
					convertisseur.setFormat(Convertisseur.TEXTE);
					convertisseur.SetSource(entreeXML.getText());
			    	if(convertisseur.Convertir(gestErreur))
			    		{
				    	 transcodeur.Transcrire("tmp.xml",filtre.getText(),sortie.getText(), gestErreur);
			    		}
				}
				else if (entreeXML.getText().endsWith(".sxw"))
				{
					convertisseur.setFormat(Convertisseur.OPENOFFICE);
					convertisseur.SetSource(entreeXML.getText());
			    	if(convertisseur.Convertir(gestErreur))
			    		{
			    		gestErreur.AfficheMessage("format OO, convertit");
				    	 //transcodeur.Transcrire("tmp.xml",filtre.getText(),fichierSortie, gestErreur);
			    		}
				}
				else
				{
					transcodeur.Transcrire(entreeXML.getText(),filtre.getText(),sortie.getText(), gestErreur);
				}
				
			}
			
			if (gestErreur.getException() == null )
			{
				//mettre en place un gestionnaire
				if (nat.getOuvrirEditeur())
				{
					AfficheFichier(sortie.getText());
				}
				btEditeur.setEnabled(true);			
			}
		}
		//ouvrir editeur
		if (evt.getSource() == btEditeur)
		{
			AfficheFichier(sortie.getText());
		}
	}
}
